OBJ
  ser : "FullDuplexSerial"

CON
  DELTA = $9e3779b9
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

VAR
  long ticks
  
DAT
  testVector long $9d204ce7, $c03677f6, $320f0555, $499c703c, $8b8af399
  long $061b6314, $7d410085, $e65b712c, $b7d23609, $0270cd59, $a23dc8d1

  key byte "0123456789ABCDEF"

  blockSize long 11

  count long 0

PUB main | persec, us
  ser.start(31, 30, 0, 115200)
  ticks := now
  btea(@testVector, -blockSize, @key)
  ticks := now - ticks
  ser.str(@testVector)
  ser.tx(13)
  ser.tx(10)
  ser.str(string("cycles elapsed = "))
  ser.dec(ticks)
  ser.tx(13)
  ser.tx(10)

  persec := 10*CLKFREQ / ticks
  us := ticks / (CLKFREQ / 1000000)

''  ser.dec(us)
''  ser.str(string(" us", 13, 10))
  ser.dec(persec)
  ser.str(string(" executions in 10 seconds", 13, 10))
  repeat
  
PUB now
  return CNT
  
PUB btea(v, n, k) | y, z, sum, p, rounds, e
  { Coding Part }
  if (n > 1)
    rounds := 6 + 52 / n
    sum := 0
    z := long[v][n - 1]
    repeat while (rounds--)
      sum += DELTA
      e :=(sum >> 2) & 3
      p := 0
      repeat while (p < n - 1)
        y := long[v][p + 1]
        z := long[v][p] += ((z >> 5 ^ y << 2) + (y >> 3 ^ z << 4)) ^ ((sum ^ y) + (long[k][(p & 3) ^ e] ^ z))
        p++
      y := long[v][0]
      z := long[v][n - 1] += ((z >> 5 ^ y << 2) + (y >> 3 ^ z << 4)) ^ ((sum ^ y) + (long[k][(p & 3) ^ e] ^ z))

  { Decoding Part }
  elseif (n < - 1)
    n := -n
    rounds := 6 + 52 / n
    sum := rounds * DELTA + DELTA
    y := long[v][0]
    repeat while ((sum -= DELTA) <> 0)
      e :=(sum >> 2) & 3
      p := n - 1
      repeat while (p > 0)
        count++
        z := long[v][p - 1]
        y := long[v][p] -= ((z >> 5 ^ y << 2) + (y >> 3 ^ z << 4)) ^ ((sum ^ y) + (long[k][(p & 3) ^ e] ^ z))
        p--
      z := long[v][n - 1]
      y := long[v][0] -= ((z >> 5 ^ y << 2) + (y >> 3 ^ z << 4)) ^ ((sum ^ y) + (long[k][(p & 3) ^ e] ^ z))
